/*****************************************************************************/
/*       (C) 1993,1994 R. NADE - M. GRANDCHAMP - All Rights Reserved         */
/*****************************************************************************/
/*    This source-code is NOT public domain nor Freeware, this is part of    */
/*              'The C Programming Package' which is Shareware.              */
/*   If you use this code, please register and get a free Full-VGA version   */
/*****************************************************************************/
                                /*----------------*
                                 *   CPPLMEN5.C   *
                                 * Menu manager5  *
                                 *----------------*/

 /* Included Files */
 # include <stdio.h>
 # include <io.h>
 # include <dos.h>
 # include <fcntl.h>
 # include <bios.h>
 # include <stdlib.h>
 # include <conio.h>

 /* Global Variables */
 extern int bm,i,j,k,l,m,n,t,x,x1,x2,xm,y,y1,y2,ym,z,menu0,menu5,return1;
 extern int colour1,colour2,colour3,colour4,colour5,returning;
 extern unsigned char c0,c1,trashcan[];

 /*----------------------*
  * CHOICE DISPLAY HELP5 *
  *----------------------*/
  void choice_display_help5()
    {
      /* We display the help that concerns the line on */
      /* which is the menu cursor (in red).            */
      if(menu5==1){
	/*  */
        display_help("MENU5   ",45,2,1);     restore_help_screen();
      }
      if(menu5==2){
	/*  */
        display_help("MENU5   ",46,3,1);     restore_help_screen();
      }
      if(menu5==3){
	/*  */
        display_help("MENU5   ",47,4,1);     restore_help_screen();
      }
      if(menu5==4){
	/*  */
        display_help("MENU5   ",48,5,1);     restore_help_screen();
      }
      if(menu5==5){
	/*  */
        display_help("MENU5   ",49,6,1);     restore_help_screen();
      }
      if(menu5==6){
	/*  */
        display_help("MENU5   ",50,7,1);     restore_help_screen();
      }
      if(menu5==7){
        /* available */
        display_help("MENU5   ",51,8,1);     restore_help_screen();
      }
      if(menu5==8){
	/*  */
        display_help("MENU5   ",52,9,1);     restore_help_screen();
      }
      if(menu5==9){
	/*  */
        display_help("MENU5   ",53,10,1);    restore_help_screen();
      }
      if(menu5==10){
	/*  */
        display_help("MENU5   ",54,11,1);    restore_help_screen();
      }
    }
 /*----------------*
  * GET THE MOUSE5 *
  *----------------*/
  int get_the_mouse5()
    {
      /* If we choose with the mouse */
      /* Only available for menu 1   */
      if(ym==1){
        /* We clicked on the first line, certainly */
        /* To change of menu.                           */
        x=get_the_mouse0();
	menu0=x;                       return(-2);
      }
      if((xm>31)&&(xm<48)){
	if(ym==3){
	  /*  */
	  menu5=1;	               return(1);
	}
	if(ym==4){
	  /*  */
	  menu5=2;                     return(1);
	}
	if(ym==5){
	  /*  */
	  menu5=3;                     return(1);
	}
	if(ym==6){
	  /*  */
	  menu5=4;                     return(1);
	}
	if(ym==7){
	  /*  */
	  menu5=5;                     return(1);
	}
	if(ym==8){
	  /*  */
	  menu5=6;                     return(1);
	}
	if(ym==9){
	  /*  */
	  menu5=7;                     return(1);
	}
	if(ym==10){
	  /*  */
	  menu5=8;                     return(1);
	}
	if(ym==11){
	  /*  */
	  menu5=9;                     return(1);
	}
	if(ym==12){
	  /*  */
	  menu5=10;                    return(1);
	}
      }
      /* If we clicked outside the menu zone            */
      /* we want to erase the menu and return to menu 0 */
      /*  */
      menu0=0;                         return(-2);
    }
 /*--------------*
  * MENU CHOICE5 *
  *--------------*/
  int menu_choice5()
    {
      returning=wait_for_a_key();
      /* Else we pressed a keyboard key                            */
      /* Cf CPPLTC2.C for the keyboard test and the returned codes */
      if(returning==-1){
        /* <Esc> we want to go back to menu0 */
	menu0=0;                       return(-2);
      }
      if(returning==40){
        /* <Enter> execute the command */
	return(1);
      }
      if(returning==100){
        /* We pressed a mouse button */
        m=get_the_mouse5();  return(m);
      }
      /* The key letters depends on the menu  */

      /* So the below returns need to be modified */
      if(returning==24){
	/* <O> <o>  */
	menu5=1;                       return(1);
      }
      if(returning==23){
	/* <N> <n>  */
	menu5=2;                       return(1);
      }
      if(returning==28){
	/* <S> <s>  */
	menu5=3;                       return(1);
      }
      if(returning==13){
	/* <D> <d>  */
	menu5=5;                       return(1);
      }
      if(returning==27){
	/* <R> <r>  */
	menu5=6;                       return(1);
      }
      if(returning==18){
	/* <I> <i>  */
	menu5=7;                       return(1);
      }
      if(returning==15){
	/* <F> <f>  */
	menu5=8;                       return(1);
      }
      if(returning==26){
	/* <Q> <q>  */
	menu5=10;	               return(1);
      }
      /* For the 2-bytes coded keys, this is the second byte */
      if(returning==59){
         /* Function key <F1> = help */
	 return(59);
      }
      if(returning>100){
        /* We pressed Alt + another key to get a menu */
        c1=returning-100;                 k=get_special_menu00();
	if(k>0)                        return(-2);
      }
      if((returning==77)||(returning==75)){
        /* Left or Right arrow to change of menu */
        c1=returning;                             k=get_special_menu00();
	if(k>0)                        return(-2);
      }
      if(returning==72){
        /* Up arrow */
	if(menu5>1)                    menu5--;
	else                           menu5=10;
	return(0);
      }
      if(returning==80){
        /* Down arrow */
	if(menu5<10)                   menu5++;
	else                           menu5=1;
	return(0);
      }
      /* Else we return 0 = no choice */
      return(0);
    }
 /*--------------------*
  * DISPLAY LINE menu5 *
  *--------------------*/
  void display_menu_line5()
    {
      /* First we display the chosen menu0 */
      textattr(colour5);
      gotoxy(33,1);                    cputs("  Menu5  ");
      /* Same thing for the selected line */
      if(menu5==1){
	gotoxy(32,3);                  cputs("                ");
      }
      if(menu5==2){
	gotoxy(32,4);                  cputs("                ");
      }
      if(menu5==3){
	gotoxy(32,5);                  cputs("                ");
      }
      if(menu5==4){
	gotoxy(32,6);                  cputs("                ");
      }
      if(menu5==5){
	gotoxy(32,7);                  cputs("                ");
      }
      if(menu5==6){
	gotoxy(32,8);                  cputs("                ");
      }
      if(menu5==7){
	gotoxy(32,9);                  cputs("                ");
      }
      if(menu5==8){
	gotoxy(32,10);                 cputs("                ");
      }
      if(menu5==9){
	gotoxy(32,11);                 cputs("                ");
      }
      if(menu5==10){
	gotoxy(32,12);                 cputs("                ");
      }
    }
 /*----------------------*
  * DISPLAY KEY LETTER 5 *
  *----------------------*/
  void display_key_letter5()
    {
      textattr(116);
      gotoxy(33,3);                   cputs(" ");
      gotoxy(33,4);                   cputs(" ");
      gotoxy(33,5);                   cputs(" ");
      gotoxy(33,6);                   cputs(" ");
      gotoxy(33,7);                   cputs(" ");
      gotoxy(33,8);                   cputs(" ");
      gotoxy(33,9);                   cputs(" ");
      gotoxy(33,10);                  cputs(" ");
      gotoxy(33,11);                  cputs(" ");
      gotoxy(33,12);                  cputs(" ");
    }
 /*---------------*
  * DISPLAY menu5 *
  *---------------*/
  void display_menu5()
    {
      /* To avoid the trace of the previous mouse position */
      /* we hide it during the display,                    */
      /* and show it when the line has been displayed.     */
      hide_the_mouse();               textattr(colour2);
      gotoxy(30,2);                    cputs(" Ŀ ");
      gotoxy(30,3);                    cputs("                  ");
      gotoxy(30,4);                    cputs("                  ");
      gotoxy(30,5);                    cputs("                  ");
      gotoxy(30,6);                    cputs("                  ");
      gotoxy(30,7);                    cputs("                  ");
      gotoxy(30,8);                    cputs("                  ");
      gotoxy(30,9);                    cputs("                  ");
      gotoxy(30,10);                   cputs("                  ");
      gotoxy(30,11);                   cputs("                  ");
      gotoxy(30,12);                   cputs("                  ");
      gotoxy(30,13);                   cputs("  ");
      display_key_letter5();           display_menu_line5();
      show_the_mouse();
    }
 /*----------------*
  * MENU MANAGER 5 *
  *----------------*/
  int menu_manager5()
    {
      restore_screen();                return1=0;
      while(1){
        display_menu5();               return1=menu_choice5();
        if(return1==-2)                return(-2);
        if(return1==-1)                return(-1);
        if(return1==22)                choice_display_help5();
        display_menu5();
        if(return1==1){
          /* We execute the selected function */
	  if(menu5==10){
            /* We want to quit the sub-program */
	    return(-1);
	  }
	  if(menu5==1){
	    /*  */

	  }
	  if(menu5==2){
	    /*  */

	  }
	  if(menu5==3){
	    /*  */

	  }
	  if(menu5==4){
	    /*  */

	  }
	  if(menu5==5){
	    /*  */

	  }
	  if(menu5==6){
	    /*  */

	  }
	  if(menu5==7){
	    /*  */

	  }
	  if(menu5==8){
	    /*  */

	  }
	  if(menu5==9){
	    /*  */

	  }
	}
      }
    }
/* End of the Module *//*----------------*/
